﻿//Copyright © 2012 Richard Y. Kain
//Written by Richard Y. Kain  based on some work by others, but all the pattern replication specifications are mine, and the
//structure of the script has been changed significantly from its previous version (written by others).
//This is called from the user-invoked script called "Specify Wallpaper using Several Patterns," that is in this
//bundle of files.
///  This script has been modified from the previous version I made so it works with the wallpaper/multiple patterns
//script - this required putting in masking and the toDo array, which iserves as the mask to govern the
//partial filling required so that another pattern can be inserted into the blank spaces.
//Also, I put in height adjustment so that the height of the first pattern governs the sizes in the result,
//but the subsequent patterns are scaled to the same height so the place gets filled whatever sizes
//were associated with the original pattern specifications. 
//I remind you that you may get very strange
//results if you forget to be sure that each pattern background is transparent and that there is something in every
//corner of the pattern, achieved by using my templates bundled along with this file.
//
//Please send any comments or suggestions to kain@umn.edu - Thanks
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//get the symetry type (an index number) from the environment
eval($.getenv("DECOsymType"));
eval($.getenv("DECOtoDos"));
eval($.getenv("DECOfirstTime"))

//Decision whether the pattern is aligned with the origin of hte layer or the origin of the selection
var alignAtSelectionOrigin = true    //use false to align the patter with the layer's origin

//TESTING
//var placesToDo = Array (true,true,true,true,false,true,true,false,true,true,true,true)

// get the size of the output area  
var outputSize = RenderAPI.getParameter(kpsSize)
// get the location of the top left corner of the bounding rectangle around the selected area
var outputOrigin = RenderAPI.getParameter(kpsOrigin)

// Get pattern and its size
var pattern = RenderAPI.getParameter(kpsPattern)
var patternSize = pattern.getParameter(kpsSize)
if (firstRender){
    var xPatternSize = patternSize.x    
    var yPatternSize = patternSize.y
    $.setenv("DECOxPatternSize", "var xPatternSize = "+xPatternSize)
    $.setenv("DECOyPatternSize", "var yPatternSize = "+yPatternSize)
    sizeRatio = 1           //no size adjustment on the first item
    }
else {
    eval($.getenv("DECOxPatternSize"))
    eval($.getenv("DECOyPatternSize"))
    sizeRatio = xPatternSize/patternSize.x
    }

//These frames are used when the symmetry requires a reflected copy of the pattern
var frame = new Frame2()
frame.setSize(1, 1)
var revframe = new Frame2()
revframe.setSize(-1, 1)      //To render the mirror image you set the frame with RenderAPI.setFrame(revframe) it's flipped horizontally
var originalRevframe = revframe

//Bookkeeping the x and y locations as API translates - this is the starting point
var xposition = 0
var yposition = 0

//The array tessSpec contains informatrion about how the plane is filled with copies of the basic module
//[0] = number of pattern copoies used, [1] == -1 if starting point is to the left of the corner (0 otherwise), 
//[2] = x offset to the next row. [3] = x offset to next copy in same row, [4] = y offset to next copy down
//Parameter information about how the tesselation is construicted from copies of the pattern goes into the following array
        repmoduleSpec = new Array()
//in this array, each entry is an array itself, specifying the reflection (or not), position, and angle of a copy of the pattern
//[0] = true if there is a reflcetion for this copy, [1] is the x position of the center of this copy, relative to the upper left corner of this 
//copy of the tesselation (measured in terms of the width of the pattern), [2] is the y position of the center (measured in 
//terms of the pattern height), [3] is the angle of rotation for this copy of the pattern

switch (symType){   
    case 0:         //p1 symmetry
        tessSpec = Array(1, 0, 0, 1, 1, 0)
        repmoduleSpec[0] = Array(false, 0.5, 0.5, 0)
        break;
    case 1:         //p2 symmetry
        tessSpec = Array(2, 0, 0.0, 1, 2, 0)  
        repmoduleSpec[0] = Array(false,  0.5, 0.5, 0)   
        repmoduleSpec[1] = Array(false, 0.5, 1.5, 180)  
        break;
    case 2:         //pm symmetry
        tessSpec = Array(2, 0, 0, 1, 2, 0)
        repmoduleSpec[0] = Array(false,  0.5, 0.5, 0) 
        repmoduleSpec[1] = Array(true, 0.5, 1.5, 180)
        break;
    case 3:         //pg symmetry
        tessSpec = Array(2, 0, 0, 2, 1, 0)
        repmoduleSpec[0] = Array(false,  0.5, 0.5, 0)  
        repmoduleSpec[1] = Array(true, 1.5, 0.5, 180)
        break;
    case 4:         //pmg symmetry
        tessSpec = Array(4, 0, 0, 2, 2, 0)
        repmoduleSpec[0] = Array(false,  0.5, 0.5, 0)
        repmoduleSpec[1] = Array(false, 1.5, 0.5, 180) 
        repmoduleSpec[2] = Array(true,  0.5, 1.5, 180) 
        repmoduleSpec[3] = Array(true, 1.5, 1.5, 0)
        break;
    case 5:         //pmm symmetry
        tessSpec = Array(4, 0, 0, 2, 2, 0)
        repmoduleSpec[0] = Array(false,  0.5, 0.5, 0) 
        repmoduleSpec[1] = Array(true, 1.5, 0.5, 00) 
        repmoduleSpec[2] = Array(true,  0.5, 1.5, 180) 
        repmoduleSpec[3] = Array(false, 1.5, 1.5, 180)
        break;
    case 6:         //cm symmetry
        tessSpec = Array(2, -1, 0.5, 1, 1, -1)
        repmoduleSpec[0] = Array(false,  0.5, 0.5, 0)
        repmoduleSpec[1] = Array(true, 0.5, 1.5, 180)
        break;
    case 7:         //pgg symmetry
        tessSpec = Array(2, 0, 0.5, 1, 1, -1)
        repmoduleSpec[0] = Array(false,  0.5, 0.5, 0)
        repmoduleSpec[1] = Array(false, 0.5, 1.5, 180)
        break;
    case 8:         //p4 symmetry
        tessSpec = Array(4, 0, 0, 2, 2, 0)
        repmoduleSpec[0] = Array(false,  0.5, 0.5, 0) 
        repmoduleSpec[1] = Array(false, 1.5, 0.5, 90)
        repmoduleSpec[2] = Array(false,  0.5, 1.5, 270)
        repmoduleSpec[3] = Array(false, 1.5, 1.5, 180) 
        break;
    case 9:         //p4m symmetry
        tessSpec = Array(8, 0, 0, 2, 2, 0)
        repmoduleSpec[0] = Array(false,  0.5, 0.5, 0)
        repmoduleSpec[1] = Array(true, 0.5, 0.5, 90)
        repmoduleSpec[2] = Array(false,  1.5, 0.5, 270)
        repmoduleSpec[3] = Array(true, 1.5, 0.5, 0)
        repmoduleSpec[4] = Array(true,  0.5, 1.5, 180)
        repmoduleSpec[5] = Array(false, 0.5, 1.5, 90)   
        repmoduleSpec[6] = Array(true,  1.5, 1.5, 270)
        repmoduleSpec[7] = Array(false, 1.5, 1.5, 180)
        break;
    case 10:       //p4g symmetry
        tessSpec = Array(8, 0, 0, 2, 2, 0)
        repmoduleSpec[0] = Array(false,  0.5, 0.5, 0)   
        repmoduleSpec[1] = Array(true, 0.5, 0.5, 90)   
        repmoduleSpec[2] = Array(true,  1.5, 0.5, 180) 
        repmoduleSpec[3] = Array(false, 1.5, 0.5, 90)   
        repmoduleSpec[4] = Array(false,  0.5, 1.5, 270)
        repmoduleSpec[5] = Array(true, 0.5, 1.5, 0)  
        repmoduleSpec[6] = Array(true,  1.5, 1.5, 270) 
        repmoduleSpec[7] = Array(false, 1.5, 1.5, 180) 
        break;
    case 11:            //cmm symmetry
        tessSpec = Array(4, -1, 0.5, 2, 1, -1)
        repmoduleSpec[0] = Array(false,  1.5, 1.5, 0)
        repmoduleSpec[1] = Array(true, 0.5, 1.5, 0) 
        repmoduleSpec[2] = Array(false,  0.5, 0.5, 180)
        repmoduleSpec[3] = Array(true, 1.5, 0.5, 180)
        break;
    case 12:            //p3 symmetry
        tessSpec = Array(3, 0, 1.5, 2, 1, -1)
        repmoduleSpec[0] = Array(false, 0.25, 0.5, 0)
        repmoduleSpec[1] = Array(false, 0.75, 1, 120) 
        repmoduleSpec[2] = Array(false,  0.25, 1.5, 240)
        break;
    case 13:            //p3m1 symmetry
        tessSpec = Array(6, 0, 0.5, 1.732, 1.732, 0)
        repmoduleSpec[0] = Array(false,  0.217, 0.433, -30) 
        repmoduleSpec[1] = Array(true, 0.433, 0, 270)
        repmoduleSpec[2] = Array(false,  1.299, 0, 90) 
        repmoduleSpec[3] = Array(true, 1.516, 0.433, 30) 
        repmoduleSpec[4] = Array(false,  1.085, 1.299, 210)
        repmoduleSpec[5] = Array(true, 0.654, 1.299, 150)
        break;
    case 14:            //p31m symmetry
        tessSpec = Array(6, -1, 0.5, 1, 3, 0)
        repmoduleSpec[0] = Array(false,  0.5, 0.5, 180)
        repmoduleSpec[1] = Array(false, 0.375, 1.25, 60) 
        repmoduleSpec[2] = Array(false, 0.625, 1.25, -60)
        repmoduleSpec[3] = Array(true, 1, 2.5, 0)   
        repmoduleSpec[4] = Array(true, 0.875, 1.75, 120) 
        repmoduleSpec[5] = Array(true, 1.125, 1.75, -120)
        break;
    case 15:            //p6 symmetry
        tessSpec = Array(6, -1, 0.5, 1, 3, 0)
        repmoduleSpec[0] = Array(false,  0.5, 0.5, 180) 
        repmoduleSpec[1] = Array(false, 0.375, 1.25, 60) 
        repmoduleSpec[2] = Array(false, 0.625, 1.25, -60) 
        repmoduleSpec[3] = Array(false, 1, 2.5, 0)
        repmoduleSpec[4] = Array(false, 0.875, 1.75, 120) 
        repmoduleSpec[5] = Array(false, 1.125, 1.75, -120)        
        break;
    case 16:            //p6m symmetry
        tessSpec = Array(12, 0, 0.5, 2, 3, 0)
        repmoduleSpec[0] = Array(false,  0.5, 2.5, 0) 
        repmoduleSpec[1] = Array(true, 0.5, 2.5, 240) 
        repmoduleSpec[2] = Array(false,  1, 2, 60) 
        repmoduleSpec[3] = Array(true, 1, 2, 300) 
        repmoduleSpec[4] = Array(false,  1.5, 2.5, 120) 
        repmoduleSpec[5] = Array(true, 1.5, 2.5, 0)   
        repmoduleSpec[6] = Array(false,  0.0, 1, -120)
        repmoduleSpec[7] = Array(true, 0.5, 0.5, 60)
        repmoduleSpec[8] = Array(false, 0.5,0.5, 180)   
        repmoduleSpec[9] = Array(true,  1.5, 0.5, 180)
        repmoduleSpec[10] = Array(false, 1.5, 0.5, -60)
        repmoduleSpec[11] = Array(true, 2, 1, 120)
        break;
}


//compute the first location and tesselation sizes, plus row and column offsets

var TessxSize = xPatternSize * tessSpec[3]
var TessySize = yPatternSize * tessSpec[4]         //NOTE that for some patterns this must be identical to the x offset
var xoffset = tessSpec[1] * xPatternSize           //This shows whether the first row starts to the left of the corner

rowoffset = tessSpec[2] 

//Set the starting point based on whether the pattern aligns with the selection or the layer
if (!alignAtSelectionOrigin)
{
    RenderAPI.translate ( -(outputOrigin.x % TessxSize), -(outputOrigin.y % TessySize))
    xposition += -(outputOrigin.x % TessxSize)
    yposition += -(outputOrigin.y % TessySize)
}


// Move to the left if the tesselation requires that
RenderAPI.translate(tessSpec[1]*TessxSize, tessSpec[5]*TessySize)
xposition = tessSpec[1]*TessxSize
yposition = tessSpec[5]*TessySize

var row = Math.floor( outputOrigin.y / TessySize )
var column = Math.floor( outputOrigin.x / TessxSize )


pattern.setParameter (kpsColorBlendMode, kpsBlendMultiply)

var firstTime = true

for (var y = 0; y < outputSize.y + TessySize;  y+= TessySize, row++)	//loop through the rows
{

//loop to go through the selection, putting down copies of the tesselation
    var x = 0
    if (firstTime){
        firstTime = false
        }
    else {   //move the bricks in the next row to the left by the offset amount
        RenderAPI.translate(-rowoffset * TessxSize, 0)
        xposition += -(rowoffset * TessxSize)
        }
     if (xposition < -tessSpec[3]*TessxSize )   //keep the offset amount within one pattern width
         {RenderAPI.translate(tessSpec[3]*TessxSize, 0)
        xposition += tessSpec[3]*TessxSize
        }
       RenderAPI.pushMatrix() 
       x = -TessxSize // one extra, just in case
 
   for (var c = column; x < outputSize.x + TessxSize * (1 + rowoffset);  x+= TessxSize, c ++)
    {
        RenderAPI.pushMatrix()
        
var refl, xoffset, yoffset, angle
//for (var i = 0; i < 3; i++)
for (var i = 0; i < tessSpec[0]; i++)       //loop to put down the patterns in one copy of the tesselation
{
    if (placesToDo[i]==0){}
    else {
refl = repmoduleSpec[i][0]
xoffset = repmoduleSpec[i][1]*xPatternSize
yoffset = repmoduleSpec[i][2]*yPatternSize
angle = repmoduleSpec[i][3]
RenderAPI.pushMatrix()
RenderAPI.translate(xoffset, yoffset)
RenderAPI.rotate(angle)
RenderAPI.setFrame(frame)       //get to ordinary frame

if (refl) {
    RenderAPI.setFrame(revframe)
    }
RenderAPI.scale(sizeRatio)
pattern.render(RenderAPI)
if (refl) {
    RenderAPI.setFrame(frame)
    }

RenderAPI.rotate(-angle)
RenderAPI.translate(-xoffset, -yoffset)
RenderAPI.popMatrix()
}

}
       RenderAPI.popMatrix()
        RenderAPI.translate(TessxSize, 0)
 //       break      //lay down only one copy of the tesselation

    }

    RenderAPI.popMatrix()
    RenderAPI.translate(0, TessySize)
 //  break      //lay down only one copy of the tesselation

}

