﻿//Copyright © 2012 Richard Y. Kain
///I think this is somewhat obvious about how it works, from the UI view. 
//This kis based on my previous script that fills the selection with wallpaper formed from
//repetitions os a single pattern. This differs in that the user can specify several patterns to
//be used in different parts of the repeated template that fills the plane. I find it interesting
//to leave some of the positions blank, which can be achieved by canceling.
//Since each time the user specifies another pattern to be used, there is a separate fill
//action in the history, so one has a (limited) possibility of going back and eliminating the
//last ones that were specified.
//The script that is called from here is a modification of the one used to fill the plane -
//the new options include the masking necessary for not filling the plane, and pattern size
//adjustments so that all patterns used in one execution of the script will be scaled to the
//same size.
// It is sometimes interesting to use patterns that are not in the correct shape. I repeat the
//note that all patterns should have trans[parent backgrounds and something in the corners 
//(If you want the corners to appear transparent, put white in there, or use my template
//files.
//Please send any comments to kain@umn.edu - Thanks  ENJOY!!!

#target photoshop

app.bringToFront();
main();
function main(){
    var lastTime = true
var updated=false;
//get list of patterns available (code by someone else)
if(!documents.length) return;
var file = File(Folder.temp +"/deco.pat"); 
if(file.exists) file.remove(); 
savePatterns( file );
  file.open("r");
  file.encoding = 'BINARY';
  var str = file.read();
  file.close();
  var patterns=[];
  var rex = /(\x00\w|\x00\d)(\x00\-|\x00\w|\x00\s|\x00\d)+\x00\x00\$[-a-z\d]+/g;
  while ((result = rex.exec(str)) != null) { 
	  var sp = result[0].toString().replace(/\x00/g, '').split('$');
	  var X = readInt16(str,(result.index+(result[0].length)+22));
	  var Y = readInt16(str,(result.index+(result[0].length)+18));
    patterns.push([[sp[0]],[sp[1]],[X],[Y]]);      
      }
patterns=ReturnUniqueSortedList(patterns);
file.remove();

//Initialize the specification of the positions to be filled
var tofill = new Array(6)
for (var i = 0; i < 5; i++) tofill[i] = true

//Make dialog box for specification originally

var win = new Window( 'dialog', '' ); 
g = win.graphics;
var myBrush = g.newBrush(g.BrushType.SOLID_COLOR, [0.99, 0.99, 0.99, 1]);
g.backgroundColor = myBrush;
win.p1= win.add("panel", undefined, undefined, {borderStyle:"black"}); 
win.g1 = win.p1.add('group');
win.g1.orientation = "row";
win.title = win.g1.add('statictext',undefined,'Symmetric Wallpaper Fill');
win.title.alignment="fill";
var g = win.title.graphics;
g.font = ScriptUI.newFont("Georgia","BOLDITALIC",22);

var symPatList =new Array()
symPatList = ['P1 symmetry','P2 symmetry','PM symmetry',
    'PG symmetry','PMG symmetry','PMM symmetry','CM symmetry',
    'PGG symmetry','P4 symmetry','P4M symmetry',
    'P4G symmetry','CMM symmetry','P3 symmetry','P3M1 symmetry','P31M symmetry',
    'P6 symmetry','P6M symmetry'];
var symPatSel = 0;//the default symmetry pattern and var to use in rest of script for reference to the patterns.

var shapeList = new Array()
shapeList = ['a rectangle','a rectangle','a rectangle','a rectangle','a rectangle','a rectangle','an isosceles triangle',
    'an isosceles triangle','a square','a 45-45-90 triangle','a 45-45-90 triangle','a right triangle','an equilateral 60 parallelogram',
    'an equilateral triangle','a 30-30-120 triangle','a 30-30-120 triangle','a 30-60-90 triangle']

win.g5 =win.p1.add('group');
win.g5.orientation = "row";
win.g5.alignment='fill';

win.g5.st1 = win.g5.add('statictext',undefined,'Please select symmetry type:');
win.g5.st1.preferredSize=[270,20];
win.g5.dd1 = win.g5.add('dropdownlist',undefined,symPatList);
win.g5.dd1.selection=0;

//Initialize the tooltip
win.g5.dd1.helpTip =  "Your pattern should be "+shapeList[0]

//update the tooltip when a symmetry has been selected
win.g5.dd1.onChange = function(){
    win.g5.dd1.helpTip =  "Your pattern should be "+shapeList[win.g5.dd1.selection.index]
}
win.g7 = win.p1.add('group');
win.g7.orientation = 'row'
win.g7.alignment='fill';
win.g7.bu1 = win.g7.add('button',undefined,'Use one pattern');
win.g7.bu1.preferredSize=[150,30];
win.g7.bu2 = win.g7.add('button',undefined,'Use several patterns');
win.g7.bu2.preferredSize=[150,30];
win.g7.bu3 = win.g7.add('button',undefined,'Cancel');
win.g7.bu3.preferredSize=[150,30];
win.g7.bu1.helpTip = "Clicking this button opens options to specify the pattern for simple a wallpaper design."
win.g7.bu2.helpTip = "Clicking this butrton will move to a window where you can choose all patterns and the places they will appear."
//Here's the activity when the box is checked - first a test whether the symmetry allows more than one pattern, 
//in which case the function does nothing. Wlse it closes this window and calls the function where locations
//and other patterns can be specified
win.g7.bu2.onClick = function(){
        if (win.g5.dd1.selection.index < 6){
            alert("This symmetry selection does not allow multiple patterns.")
            }
        else { 
            win.close(0)     //close this window to prepare for the one with location selection information
            doNow = Array(0,0,0,0,0,0,0,0,0,0,0,0)
            doSeveral(symPatList[win.g5.dd1.selection.index], win.g5.dd1.selection.index, shapeList[win.g5.dd1.selection.index])     //call the looping structure that gets all patterns rendered
            }       //all finished!!
}       //emd of the severalBOx onClick function having the specification/activity for going to multiple patterns
win.g7.bu1.onClick = function(){    //turn off the option of multiple patterns and show the single pattern controls
        win.g7.visible = false
        win.g10.visible = true
        win.g15.visible = true
        win.g20.visible = true
        win.g100.visible = true
        doNow = Array(1,1,1,1,1,1,1,1,1,1,1,1)
        visibility = Array(false,false,false,false,false,false,false,false,false,false,false,false)     //there's nothing extra to do (contrast with doSeveral interface)
        firstTime = true            //need this to disable size adjustment in the rendering script
}
win.g7.bu3.onClick = function(){
        win.close(0)
}

win.g10 =win.p1.add('group');
win.g10.orientation = "row";
win.g10.alignment='fill';
win.g10.st1 = win.g10.add('statictext',undefined,'Please select pattern:');
win.g10.st1.preferredSize=[270,20];
win.g10.dd1 = win.g10.add('dropdownlist');
for(var p in patterns){win.g10.dd1.add('item',patterns[p][0]);}
win.g10.dd1.selection=0; 

//win.g10.dd1.onChange();
win.g15 =win.p1.add('group');
win.g15.orientation = "row";
win.g15.alignment='fill';
var Blend = ['Normal','Dissolve','-','Darken','Multiply','Color Burn','Linear Burn','Darker Color','-','Lighten','Screen','Color Dodge',
    'Linear Dodge (Add)','Lighter Color','-','Overlay','Soft Light','Hard Light','Vivid Light','Linear Light', 'Pin Light','Hard Mix','-','Difference', 'Exclusion',
    'Subtract','Divide','-','Hue','Saturation','Color','Luminosity'];
var bMode=['Nrml','Dslv','-','Drkn','Mltp','CBrn','linearBurn','darkerColor','-','Lghn', 'Scrn',
'CDdg','linearDodge','lighterColor','-','Ovrl','SftL','HrdL','vividLight','linearLight','pinLight','hardMix','-',
'Dfrn','Xclu','blendSubtraction','blendDivide','-','H   ','Strt','Clr ','Lmns'];
win.g15.st1 = win.g15.add('statictext',undefined,'Blend mode:');
win.g15.st1.preferredSize=[270,20];
win.g15.dd1 = win.g15.add('dropdownlist',undefined,Blend);
win.g15.dd1.selection=0;
win.g20 =win.p1.add('group');
win.g20.orientation = "row";
win.g20.alignment='fill';
win.g20.st1 = win.g20.add('statictext',undefined,'Opacity:');
win.g20.st1.preferredSize=[270,20];
win.g20.et1 = win.g20.add('edittext',undefined,'100');
win.g20.et1.preferredSize=[30,20];
win.g20.et1.onChanging = function() { 
  if (this.text.match(/[^\-\.\d]/)) { 
    this.text = this.text.replace(/[^\-\.\d]/g, ''); 
  } 
};

//Here's the last row of the window
var pictureFlag = true          //flag about whether you choose to select patterns by name or by picture
win.g100 =win.p1.add('group');
win.g100.orientation = "row";
win.g100.alignment='center';
win.g100.bu1 = win.g100.add('button',undefined,'Paint pattern copies');
win.g100.bu1.preferredSize=[150,30];
win.g100.bu1.helpTip = "Complete wallpaper using the pattern you selected by name above"
win.g100.bu3 = win.g100.add('button',undefined,'See pattern pictures');
win.g100.bu3.preferredSize=[150,30];
win.g100.bu3.helpTip = "View the pattern fill dialog and choose the pattern from small icons"
win.g100.bu2 = win.g100.add('button',undefined,'Cancel');
win.g100.bu2.onClick=function(){
    win.close(0);
}

win.g100.bu2.preferredSize=[150,30];

//Initial hiding of the window elements for a single pattern
      win.g10.visible = false
        win.g15.visible = false
        win.g20.visible = false
        win.g100.visible = false

///Here's handling off the filling function for a single pattern

win.g100.bu1.onClick=function(){
win.close(0);
pictureFlag = false;

if (updated==true){
var idslct = charIDToTypeID( "slct" );
    var desc4 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref4 = new ActionReference();
        var idHstS = charIDToTypeID( "HstS" );
        var idOrdn = charIDToTypeID( "Ordn" );
        var idPrvs = charIDToTypeID( "Prvs" );
        ref4.putEnumerated( idHstS, idOrdn, idPrvs );
    desc4.putReference( idnull, ref4 );
executeAction( idslct, desc4, DialogModes.NO );
}
updated=true;

//HERE''s where the actual drawing gets started

doit(pictureFlag, doNow);
app.refresh()
}       //end finction for using the patterns by name

win.g100.bu3.onClick=function(){
 pictureFlag = true;
win.close(0);
doit(pictureFlag, doNow);
app.refresh()
}       //end finction for using the patterns by pictures - through the fill dialog box

function doit(useFillBoxFlag, doWhich) {
//set temp vars in memory

$.setenv("DECOsymType","var symType = "+win.g5.dd1.selection.index+";")
$.setenv("DECOtoDos","var placesToDo = ["+doWhich.toString()+"];");
$.setenv("DECOfirstTime","var firstRender = "+firstTime);

//call fill menu
var Name = patterns[win.g10.dd1.selection.index][0];
var PatID = patterns[win.g10.dd1.selection.index][1];
var BMODE = bMode[win.g15.dd1.selection.index];
var Opacity = Number(win.g20.et1.text);
if(Opacity > 100) Opacity = 100;
if(Opacity < 0) Opacity = 0;
try{
decoFill(Name,PatID,BMODE,Opacity,useFillBoxFlag);
}catch(e){}
}



//The following function encalsulates the activites for multiple patterns in a wallpaper design
function doSeveral(symName, symIndex, shapeName){

//define symmetry specifications
//The howToFill array entries correspond to the positions used in the rendering script; they contain the index of the button that is used to specify this.
switch (symIndex){
    case 6:         //cm symmetry
        visibility = Array(false,false,true,false,false,false,false,false,true,false,false,false)
        howToFill = Array(2, 8) 
        picturefile = app.path +"/Presets/Deco/cmShape.jpg"
        break;
    case 7:         //pgg symmetry
        visibility = Array(false,false,true,false,false,false,false,false,true,false,false,false)
        howToFill = Array(2, 8)
        picturefile = app.path +"/Presets/Deco/cmShape.jpg"
        break;
    case 8:         //p4 symmetry
        visibility = Array(true,false,true,false,false,false,true,false,true,false,false,false)
        howToFill = Array(0, 2, 8, 6)
        picturefile = app.path +"/Presets/Deco/p4Shape.jpg"
        break;
    case 9:         //p4m symmetry 
        visibility = Array(false,true,false,true,false,true,false,true,false,false,false,false)
        howToFill = Array(1,3,3,1,7,5,5,7)
        picturefile = app.path +"/Presets/Deco/p4mShape.jpg"
        break;
    case 10:       //p4g symmetry
        visibility = Array(false,true,false,true,false,true,false,true,false,false,false,false)
        howToFill = Array(1,3,3,1,7,5,5,7)
        picturefile = app.path +"/Presets/Deco/p4mShape.jpg"
        break;
    case 11:            //cmm symmetry
        visibility = Array(false,true,false,true,false,true,false,true,false,false,false,false)
        howToFill = Array(7,3,5,1)
        picturefile = app.path +"/Presets/Deco/p4mShape.jpg"
        break;
    case 12:            //p3 symmetry
        visibility = Array(false,true,false,false,true,false,false,true,false,false,false,false)
        howToFill = Array(1,4,7)
        picturefile = app.path +"/Presets/Deco/p3Shape.jpg"
        break;
    case 13:            //p3m1 symmetry
        visibility = Array(true,false,true,false,true,false,true,false,true,false,true,false)
        howToFill = Array(10,0,2,4,6,8)
        picturefile = app.path +"/Presets/Deco/p3m1Shape.jpg"
        break;
    case 14:            //p31m symmetry
        visibility = Array(false,false,false,true,false,false,false,true,false,false,false,true)
        howToFill = Array(7,11,3,7,11,3)
        picturefile = app.path +"/Presets/Deco/p31mShape.jpg"
        break;
    case 15:            //p6 symmetry
        visibility = Array(false,false,false,true,false,false,false,true,false,false,false,true)
        howToFill = Array(7,11,3,7,11,3)
        picturefile = app.path +"/Presets/Deco/p31mShape.jpg"
        break;
    case 16:            //p6m symmetry
        visibility = Array(true,false,true,false,false,true,true,false,true,false,false,true)
        howToFill = Array(6,6,5,5,8,8,2,2,11,11,0,0)
        picturefile = app.path +"/Presets/Deco/p6mShape.jpg"
        break;
}
firstTime = true
lastTime = false

for (var y = 0;!lastTime; y++) {                //the top of the large loop to get several windows in sequence
//Here's the window for this function - it is activated from inside a loop waiting for all to be filled
var win2 = new Window( 'dialog', '' ); 
g = win2.graphics;
var myBrush = g.newBrush(g.BrushType.SOLID_COLOR, [0.99, 0.99, 0.99, 1]);
g.backgroundColor = myBrush;
win2.p1= win2.add("panel", undefined, undefined, {borderStyle:"black"}); 
win2.g1 = win2.p1.add('group');
win2.g1.orientation = "row";
win2.title = win2.g1.add('statictext',undefined,'Symmetric Wallpaper Fill');
win2.title.alignment="fill";
var g = win2.title.graphics;
g.font = ScriptUI.newFont("Georgia","BOLDITALIC",22);

win2.g5 =win2.p1.add('group');
win2.g5.orientation = "row";
win2.g5.alignment='center';
symMessage = "You chose "+symName+". Each pattern should be "+shapeName+"."
win2.g5.st1 = win2.g5.add('statictext',undefined,symMessage)
//win2.g5.st1.preferredSize=[270,20];

win2.g10 =win2.p1.add('group');
win2.g10.orientation = "row";
win2.g10.alignment='fill';
win2.g10.st1 = win2.g10.add('statictext',undefined,'Please select the next pattern:');
win2.g10.st1.preferredSize=[270,20];
win2.g10.dd1 = win2.g10.add('dropdownlist');

for(var p in patterns){win2.g10.dd1.add('item',patterns[p][0]);}
win2.g10.dd1.selection=0; 

win2.g15 =win2.p1.add('group');
win2.g15.orientation = "row";
win2.g15.alignment='fill';
win2.g15.st1 = win2.g15.add('statictext',undefined,'Blend mode:');
win2.g15.st1.preferredSize=[270,20];
win2.g15.dd1 = win2.g15.add('dropdownlist',undefined,Blend);
win2.g15.dd1.selection=0;
win2.g20 =win2.p1.add('group');
win2.g20.orientation = "row";
win2.g20.alignment='fill';
win2.g20.st1 = win2.g20.add('statictext',undefined,'Opacity:');
win2.g20.st1.preferredSize=[270,20];
win2.g20.et1 = win2.g20.add('edittext',undefined,'100');
win2.g20.et1.preferredSize=[30,20];
win2.g20.et1.onChanging = function() { 
  if (this.text.match(/[^\-\.\d]/)) { 
    this.text = this.text.replace(/[^\-\.\d]/g, ''); 
  } 
};

win2.g11 =win2.p1.add('group');
win2.g11.orientation = "row";
win2.g11.alignment='fill';
win2.g11.st2 = win2.g11.add('statictext',undefined,'Now use checkboxes to specify positions for this pattern.');



//Here's the complex portion with the pattern image and selection buttons when several patterns are being used
patterngroup = 
    "Group { orientation: 'row', alignment: 'center',\
        LButtons: Group {orientation: 'column', alignment: 'center'},\
        Middle: Group {orientation: 'column', alignment: 'fill',\
            topRow: Group {orientation: 'row', alignment: 'center'},\
            MiddleBox: Group {orientation: 'row', alignment: 'center'},\
            bottomRow: Group {orientation: 'row', alignment: 'center'},\
            }\
        RButtons: Group {orientation: 'column', alignment: 'center'},\
    }"
win2.g25 = win2.p1.add(patterngroup)
imagespace = win2.g25.Middle.MiddleBox.add('image',[0,0,175,175],picturefile)
boxes = new Array (12)
boxes[11] = win2.g25.LButtons.add('checkbox',[0,0,30,30],"")
boxes[10] = win2.g25.LButtons.add('checkbox',[0,0,30,30],"")
boxes[09] = win2.g25.LButtons.add('checkbox',[0,0,30,30],"")
boxes[00] = win2.g25.Middle.topRow.add('checkbox',[0,0,30,30],"")
boxes[01] = win2.g25.Middle.topRow.add('checkbox',[0,0,30,30],"")
boxes[02] = win2.g25.Middle.topRow.add('checkbox',[0,0,30,30],"")
boxes[08] = win2.g25.Middle.bottomRow.add('checkbox',[0,0,30,30],"")
boxes[07] = win2.g25.Middle.bottomRow.add('checkbox',[0,0,30,30],"")
boxes[06] = win2.g25.Middle.bottomRow.add('checkbox',[0,0,30,30],"")
boxes[03] = win2.g25.RButtons.add('checkbox',[0,0,30,30],"")
boxes[04] = win2.g25.RButtons.add('checkbox',[0,0,30,30],"")
boxes[05] = win2.g25.RButtons.add('checkbox',[0,0,30,30],"")


    for (var i = 0; i < 12; i++) { 
    boxes[i].visible = visibility[i]
    boxes[i].value = false
    }

//Here's the last row of the window
var pictureFlag = true          //flag about whether you choose to select patterns by name or by picture
win2.g100 =win2.p1.add('group');
win2.g100.orientation = "row";
win2.g100.alignment='center';
win2.g100.bu1 = win2.g100.add('button',undefined,'Paint pattern copies');
win2.g100.bu1.preferredSize=[150,30];
win2.g100.bu1.helpTip = "Complete wallpaper using the pattern you selected by name above"
win2.g100.bu3 = win2.g100.add('button',undefined,'See pattern pictures');
win2.g100.bu3.preferredSize=[150,30];
win2.g100.bu3.helpTip = "View the pattern fill dialog and choose the pattern by seeing a small icon of each one"
win2.g100.bu2 = win2.g100.add('button',undefined,'Cancel');
win2.g100.bu2.preferredSize=[150,30];

//Cancel button pushed
win2.g100.bu2.onClick=function(){
    win2.close(0);
    lastTime = true       //have to leave the repetitive loop
}

//The button for doing a fill with the named pattern has been pushed
win2.g100.bu1.onClick=function(){
win2.close(0);
pictureFlag = false;

if (updated==true){
var idslct = charIDToTypeID( "slct" );
    var desc4 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref4 = new ActionReference();
        var idHstS = charIDToTypeID( "HstS" );
        var idOrdn = charIDToTypeID( "Ordn" );
        var idPrvs = charIDToTypeID( "Prvs" );
        ref4.putEnumerated( idHstS, idOrdn, idPrvs );
    desc4.putReference( idnull, ref4 );
executeAction( idslct, desc4, DialogModes.NO );
}
updated=true;
    doNow = Array (0,0,0,0,0,0,0,0,0,0,0,0) //initialize to do nothing
    lastTime = true     //will be negated if a box in not checked
    for (var i = 0; i < howToFill.length; i++){
        checkThis = howToFill[i]        //index of the box that might be checked
        if (!boxes[checkThis].value) { 
            if (boxes[checkThis].visible){
            lastTime = false}
            else {}
            }
        else {
            visibility[checkThis] = false     //make the box disappear the next time
//            boxes[checkThis].value = false
            doNow[i] = 1                             //turn on writing in this position this time
        }
    }
doit(pictureFlag, doNow);
firstTime = false

}       //end finction for using the patterns by name


//The button to see the patterns has been pushed
win2.g100.bu3.onClick=function(){
 pictureFlag = true;
win2.close(0);
    doNow = Array (0,0,0,0,0,0,0,0,0,0,0,0) //initialize to do nothing
    lastTime = true     //will be negated if a box in not checked
    for (var i = 0; i < howToFill.length; i++){
        checkThis = howToFill[i]        //index of the box that might be checked
        if (!boxes[checkThis].value ) {
            if (boxes[checkThis].visible){
            lastTime = false}
            else {}
            }
        else {
            visibility[checkThis] = false     //make the box disappear the next time
//            boxes[checkThis].value = false
            doNow[i] = 1                             //turn on writing in this position this time
        }
    }
doit(pictureFlag, doNow);
firstTime = false
}       //end finction for using the patterns by pictures - through the fill dialog box

win2.center()
win2.show()
}                           //end of the for loop over copies of the window
//app.refresh()
}       //END OF FUNCTION DO SEVERAL


win.center();       //ACTUALLY SHOWS  THE FIRST WINDOW HERE
win.show();

}               //END of mail program - exits here even if we used several patterns


function buttonCheck(howToFill) {
    lastTime = true     //will be negated if a box in not checked
    for (var i = 0; i < howToFill.length; i++){
        checkThis = howToFill[i]        //index of the box that might be checked
        if (boxes[checkThis].state == false) { lastTime = false}
        else {
            boxes[checkThis].visibility = false     //make the box disappear the next time
            doNow[i] = 1                             //turn on writing in this position this time
        }
    }
//    return doNow
}
function readByte(str, ofs) {
    return str.charCodeAt(ofs);
  }
function readInt16(str, ofs) {
    return (readByte(str, ofs) << 8) + readByte(str, ofs+1);
  }


function decoFill(Name,PatID,BMODE,Opacity,useFillBoxFlag) {
    if(BMODE.length> 4) {
        var blendMode ="stringIDToTypeID(BMODE);";
        }else{
            var blendMode = "charIDToTypeID(BMODE);";
            }
    var desc16 = new ActionDescriptor();
    desc16.putEnumerated( charIDToTypeID('Usng'), charIDToTypeID('FlCn'), charIDToTypeID('Ptrn') );
        var desc17 = new ActionDescriptor();
        desc17.putString( charIDToTypeID('Nm  '), Name.toString());
        desc17.putString( charIDToTypeID('Idnt'), PatID.toString());
    desc16.putObject( charIDToTypeID('Ptrn'), charIDToTypeID('Ptrn'), desc17 );
    desc16.putPath( stringIDToTypeID('decoScriptFile'), new File( app.path +"/Presets/Deco/PartialPlaneSymmetryFill.jsx" ) );      //version B is for checking out size adjustments
    desc16.putUnitDouble( charIDToTypeID('Opct'), charIDToTypeID('#Prc'), Number(Opacity) );
    desc16.putEnumerated( charIDToTypeID('Md  '), charIDToTypeID('BlnM'), eval(blendMode));
    try{
        if (useFillBoxFlag) {
    executeAction( charIDToTypeID('Fl  '), desc16, DialogModes.ALL )}
        else {
    executeAction( charIDToTypeID('Fl  '), desc16, DialogModes.NO );}
    }catch(e){return;}
};

//The rest of this is fuc\nctions supporting listing pattern names
function savePatterns( file ) { 
    var desc = new ActionDescriptor(); 
    desc.putPath( charIDToTypeID( "null" ), new File(file) ); 
        var ref = new ActionReference(); 
        ref.putProperty( charIDToTypeID( "Prpr" ), charIDToTypeID( "Ptrn" ) ); 
        ref.putEnumerated( charIDToTypeID( "capp" ), charIDToTypeID( "Ordn" ), charIDToTypeID( "Trgt" ) ); 
    desc.putReference( charIDToTypeID( "T   " ), ref ); 
executeAction( charIDToTypeID( "setd" ), desc, DialogModes.NO ); 
}; 
function ReturnUniqueSortedList(ArrayName){
var unduped = new Object;
for (var i = 0; i < ArrayName.length; i++) {   
unduped[ArrayName[i]] = ArrayName[i];
}
var uniques = new Array;for (var k in unduped) {
   uniques.push(unduped[k]);}
return uniques.sort();
}